动态规划 13. 完全背包问题解法

52. 携带研究材料(第七期模拟笔试)

代码随想录

可以结合动态规划 8. 01背包问题解法(二维dp数组、滚动数组)以及python中输入的处理方法-CSDN博客对比学习

自己没想出来,看了一下代码随想录里的分析就想出来了,

代码随想录里的分析写的很好,直接摘录放在最后了,供参考

思路

  • 关键点
    • 完全背包和01背包问题唯一不同的地方就是,每种物品有无限件。

    • 重要的区别,在于对递推关系的分析!

  • 分析

    下面以二维dp为例进行分析,因为二维dp是问题的本质,

    而一维dp是问题的优化,理解透了二维dp就能很方便的写出一维dp!

    • dp定义:

      ​​dp[i][j]​ ​ 表示从下标为​ ​[0-i]​ ​的物品,每个物品可以取无限次,放进容量为​​j​​的背包,价值总和最大是多少

    • dp递推:

      完全背包中,dp[i][j]​的来源有如下两种情况:

      • 不取物品​​i​​:

        背包容量为j​,里面不放物品i​的最大价值是dp[i - 1][j]​;

        因为:只从​​0~i​​索引取物品,若不放物品​​i​​ ,只能从上一层​​0~i-1​​索引物品里面找到最优方案(最优价值)。

        直观理解:从当前格子​​dp[i][j]​ ​的正上方格子​​dp[i - 1][j]​ ​获取信息来源

      • 取物品​​i​​:

        背包空出物品i​的容量后,背包容量为j - weight[i]​,

        dp[i][j - weight[i]]​ 为背包容量为j - weight[i]​且不放物品i​的最大价值,

        那么dp[i][j - weight[i]] + value[i]​ (物品i​的价值),就是背包放物品i​得到的最大价值。

        因为:放了物品​​i​​之后,剩下的背包空间为​​j - weight[i]​ ​ ,

        由于是完全背包,物品是可以取无限个,所以 即使给物品​​i​​留出了一个空间重量,那背包中也可能还有物品​​i​​ !

        因此当行(物品​​i​​ )固定,从左到右遍历背包容量(​​j​​依次增大)时,

        遍历到背包容量​​j​​的时候,需要向同一行的(或者说已更新的,如果用一维dp去理解)​​dp[i][j - weight[i]]​ ​索取贡献,

        因此当前的取物品​​i​​的情况,最终的最大价值为​​dp[i][j - weight[i]] + value[i]​ ​

        直观理解:从当前格子​​dp[i][j]​ ​的正左方格子​​dp[i][j - weight[i]]​ ​获取信息来源

      递推公式: ​dp[i][j] = max(dp[i - 1][j], dp[i][j - weight[i]] + value[i]);​ ​

      (注意,完全背包二维dp数组 和 01背包二维dp数组 递推公式的区别,01背包中是 dp[i - 1][j - weight[i]] + value[i])​)

    • dp初始化:

      方法一:完整的初始化

      • 首先从dp[i][j]​的定义出发,如果背包容量j​为0的话,即dp[i][0]​,无论是选取哪些物品,背包价值总和一定为0

      • 状态转移方程 dp[i][j] = max(dp[i - 1][j], dp[i][j - weight[i]] + value[i]);​

        可以看出有一个方向 i​ 是由 i-1​ 推导出来,那么i​为0的时候就一定要初始化。

        ​dp[0][j]​,即:存放编号0的物品的时候,各个容量的背包所能存放的最大价值。

        那么很明显当 ​j < weight[0]​ ​的时候,​​dp[0][j]​ ​ 应该是 0,因为背包容量比编号0的物品重量还小。

        当j >= weight[0]​时,​dp[0][j]​ ​ 如果能放下​​weight[0]​ ​的话,就一直装,每一种物品有无限个。

        代码初始化如下:

        for (int i = 1; i < weight.size(); i++) {  // 当然这一步,如果把dp数组预先初始化为0了,这一步就可以省略,但很多同学应该没有想清楚这一点。
            dp[i][0] = 0;
        }
        
        // 正序遍历,如果能放下就一直装物品0
        for (int j = weight[0]; j <= bagWeight; j++)
            dp[0][j] = dp[0][j - weight[0]] + value[0];
        

        (注意上面初始化和 01背包理论基础(二维数组) (opens new window)的区别在于物品有无限个)

      方法二:简易的初始化

      令物品种类数为n​,行李最大容量为bagSize​

      • 我们可以参考之前滚动数组和二维dp之间初始化的区别,前者往往更简单,

        因此,将滚动数组的初始化思路换到二维dp中就是:

        二维dp原本开的空间为:n * (bagSize + 1)​,这会导致需要单独对i = 0​的情况进行从初始化。

        那么,我们现在**调整二维dp的形状为:**​ ​(n + 1) * (bagSize + 1)​ ​

        这样,用​​n+1​​作为物品维度数,我们只需要正确初始化行0(这道题中是全初始化为0),​​i == 1​​时,再取用物品0,

        这样物品索引​​0~n-1​​对应着​​i​​的值从​​1~n​​,

        在物品的遍历中,我们采用for i in range(1, n + 1)​,就可以自动更新物品0取用时的情况!

        (因为在遍历过程中,如果从物品0开始迭代,则需要调取物品0正上方的格子,但是按照原本的定义,物品0正上方没有格子了!所以一定得先初始化物品0对应的行,才能从下一行开始迭代。而现在多加了一行初始化行,物品0也可以直接放入遍历中进行迭代更新,因此就不需要多写一个对物品0行的初始化了!)

      • 但是要注意,一定要牢记物品索引​​0~n-1​​对应着​​i​​的值从​​1~n​​,否则很容易出错。

      • 在这种初始化中,我们的dp定义变成了:

        ​dp[i][j]​表示从0~i-1​索引取用物品背包容量为j​时,可以携带的最大价值的研究材料

    • dp遍历顺序:

      外循环:物品维度,正序

      内循环:背包容量维度,正序!

      (即便是一维dp中背包容量维度也需要正序遍历,注意一维dp的遍历范围是​​range(weights[i], bagSize + 1)​ ​ )

二维dp代码

  • 用第二种简易初始化方法的代码:

    import sys
    lines = sys.stdin.readlines()
    
    n, bagSize = map(int, lines[0].strip().split()) # 物品种类数,行李最大容量
    weights = [0] * n
    values = [0] * n
    for i in range(n):
        weights[i], values[i] = map(int, lines[i+1].strip().split())
    
    # dp[i][j]表示从0~i-1索引取用物品背包容量为j时,可以携带的最大价值的研究材料
    # 注意,这里的定义特意是用了n+1作为物品维度数,是因为这样与滚动数组法就能联动,初始化起来类似滚动数组法,更方便了
    # i == 0时,表示初始化;i == 1时,取用物品0
    dp = [[0] * (bagSize + 1) for _ in range(n + 1)]
    
    for i in range(1, n + 1): # 物品维度,注意这里的遍历的起始和终止点!
        for j in range(bagSize + 1): # 背包容量维度
            # 放不进当前物品i-1时(注意这里i对应物品索引i-1)
            if j < weights[i-1]: 
                dp[i][j] = dp[i-1][j]
            else:
                dp[i][j] = max(dp[i-1][j], 
                            dp[i][j-weights[i-1]] + values[i-1])
    
    print(dp[-1][-1])
    
    
  • 用第一种常规初始化方法的代码:

    import sys
    lines = sys.stdin.readlines()
    
    n, bagSize = map(int, lines[0].strip().split()) # 物品种类数,行李最大容量
    weights = [0] * n
    values = [0] * n
    for i in range(n):
        weights[i], values[i] = map(int, lines[i+1].strip().split())
    
    # dp[i][j]表示从0~i索引取用物品背包容量为j时,可以携带的最大价值的研究材料
    dp = [[0] * (bagSize + 1) for _ in range(n)]
    # 初始化最上行 (最左列由于已经全部设置为0,就不用再手动初始化了)
    for j in range(weights[0], bagSize + 1):
        dp[0][j] = dp[0][j - weights[0]] + values[0]
    
    for i in range(1, n): # 物品维度,注意这里的遍历的起始和终止点!
        for j in range(bagSize + 1): # 背包容量维度
            # 放不进当前物品i时
            if j < weights[i]: 
                dp[i][j] = dp[i-1][j]
            else:
                dp[i][j] = max(dp[i-1][j], 
                            dp[i][j-weights[i]] + values[i])
    
    print(dp[-1][-1])
    

一维dp代码

  • 一维dp就好写很多,不需要写那么长段

    但是要记住,完全背包的一维dp,遍历物品重量时,要从左往右正序遍历了!

    这一点是与01背包不同的

    import sys
    lines = sys.stdin.readlines()
    
    n, bagSize = map(int, lines[0].strip().split()) # 物品种类数,行李最大容量
    weights = [0] * n
    values = [0] * n
    for i in range(n):
        weights[i], values[i] = map(int, lines[i+1].strip().split())
    
    # dp[j]表示背包容量为j时,可以携带的最大价值的研究材料
    dp = [0] * (bagSize + 1)
    
    for i in range(n):
        for j in range(weights[i], bagSize + 1):
            dp[j] = max(
                dp[j], 
                dp[j-weights[i]] + values[i]
                )
    
    print(dp[-1])
    

代码随想录的分析摘录

  • 完全背包

    有N件物品和一个最多能背重量为W的背包。第i件物品的重量是weight[i],得到的价值是value[i] 。每件物品都有无限个(也就是可以放入背包多次) ,求解将哪些物品装入背包里物品价值总和最大。

    完全背包和01背包问题唯一不同的地方就是,每种物品有无限件。

    同样leetcode上没有纯完全背包问题,都是需要完全背包的各种应用,需要转化成完全背包问题,所以我这里还是以纯完全背包问题进行讲解理论和原理。

    在下面的讲解中,我拿下面数据举例子:

    背包最大重量为4,物品为:

    重量价值
    物品0115
    物品1320
    物品2430

    每件商品都有无限个!

    问背包能背的物品最大价值是多少?

    如果没看到之前的01背包讲解,已经要先仔细看如下两篇,01背包是基础,本篇在讲解完全背包,之前的背包基础我将不会重复讲解。

    动规五部曲分析完全背包,为了从原理上讲清楚,我们先从二维dp数组分析:

    1. 确定dp数组以及下标的含义

    dp[i][j] 表示从下标为[0-i]的物品,每个物品可以取无限次,放进容量为j的背包,价值总和最大是多少。

    很多录友也会疑惑,凭什么上来就定义 dp数组,思考过程是什么样的, 这个思考过程我在 01背包理论基础(二维数组) (opens new window)中的 “确定dp数组以及下标的含义” 有详细讲解。

    2. 确定递推公式

    这里在把基本信息给出来:

    重量价值
    物品0115
    物品1320
    物品2430

    对于递推公式,首先我们要明确有哪些方向可以推导出 dp[i][j]。

    这里依然拿dp[1][4]的状态来举例: (01背包理论基础(二维数组) (opens new window)中也是这个例子,要注意下面的不同之处)

    求取 dp[1][4] 有两种情况:

    1. 放物品1
    2. 还是不放物品1

    如果不放物品1, 那么背包的价值应该是 dp[0][4] 即 容量为4的背包,只放物品0的情况。

    推导方向如图:

    如果放物品1, 那么背包要先留出物品1的容量,目前容量是4,物品1 的容量(就是物品1的重量)为3,此时背包剩下容量为1。

    容量为1,只考虑放物品0 和物品1 的最大价值是 dp[1][1], 注意 这里和 01背包理论基础(二维数组) (opens new window)​有所不同了!

    在 01背包理论基础(二维数组) (opens new window)中,背包先空留出物品1的容量,此时容量为1,只考虑放物品0的最大价值是 dp[0][1],因为01背包每个物品只有一个,既然空出物品1,那背包中也不会再有物品1!

    而在完全背包中,物品是可以放无限个,所以 即使空出物品1空间重量,那背包中也可能还有物品1,所以此时我们依然考虑放 物品0 和 物品1 的最大价值即: dp[1][1], 而不是 dp[0][1]

    所以 放物品1 的情况 = dp[1][1] + 物品1 的价值,推导方向如图:

    (注意上图和 01背包理论基础(二维数组) (opens new window)​中的区别,对于理解完全背包很重要)

    两种情况,分别是放物品1 和 不放物品1,我们要取最大值(毕竟求的是最大价值)

    ​dp[1][4] = max(dp[0][4], dp[1][1] + 物品1 的价值)​

    以上过程,抽象化如下:

    • 不放物品i:背包容量为j,里面不放物品i的最大价值是dp[i - 1][j]。
    • 放物品i:背包空出物品i的容量后,背包容量为j - weight[i],dp[i][j - weight[i]] 为背包容量为j - weight[i]且不放物品i的最大价值,那么dp[i][j - weight[i]] + value[i] (物品i的价值),就是背包放物品i得到的最大价值

    递推公式: dp[i][j] = max(dp[i - 1][j], dp[i][j - weight[i]] + value[i]);​

    (注意,完全背包二维dp数组 和 01背包二维dp数组 递推公式的区别,01背包中是 dp[i - 1][j - weight[i]] + value[i])​)

    3. dp数组如何初始化

    关于初始化,一定要和dp数组的定义吻合,否则到递推公式的时候就会越来越乱。

    首先从dp[i][j]的定义出发,如果背包容量j为0的话,即dp[i][0],无论是选取哪些物品,背包价值总和一定为0。如图:

    动态规划-背包问题2

    在看其他情况。

    状态转移方程 dp[i][j] = max(dp[i - 1][j], dp[i][j - weight[i]] + value[i]);​ 可以看出有一个方向 i 是由 i-1 推导出来,那么i为0的时候就一定要初始化。

    dp[0][j],即:存放编号0的物品的时候,各个容量的背包所能存放的最大价值。

    那么很明显当 j < weight[0]​的时候,dp[0][j] 应该是 0,因为背包容量比编号0的物品重量还小。

    当j >= weight[0]​时,dp[0][j] 如果能放下weight[0]的话,就一直装,每一种物品有无限个。

    代码初始化如下:

    for (int i = 1; i < weight.size(); i++) {  // 当然这一步,如果把dp数组预先初始化为0了,这一步就可以省略,但很多同学应该没有想清楚这一点。
        dp[i][0] = 0;
    }
    
    // 正序遍历,如果能放下就一直装物品0
    for (int j = weight[0]; j <= bagWeight; j++)
        dp[0][j] = dp[0][j - weight[0]] + value[0];
    

    (注意上面初始化和 01背包理论基础(二维数组) (opens new window)的区别在于物品有无限个)

    此时dp数组初始化情况如图所示:

    dp[0][j] 和 dp[i][0] 都已经初始化了,那么其他下标应该初始化多少呢?

    其实从递归公式: dp[i][j] = max(dp[i - 1][j], dp[i][j - weight[i]] + value[i]); 可以看出dp[i][j] 是由上方和左方数值推导出来了,那么 其他下标初始为什么数值都可以,因为都会被覆盖。

    但只不过一开始就统一把dp数组统一初始为0,更方便一些。

    最后初始化代码如下:

    // 初始化 dp
    vector<vector<int>> dp(weight.size(), vector<int>(bagweight + 1, 0));
    for (int j = weight[0]; j <= bagWeight; j++) {
        dp[0][j] = dp[0][j - weight[0]] + value[0]; 
    }
    

    4. 确定遍历顺序

    01背包理论基础(二维数组) (opens new window)中我们讲过,01背包二维DP数组,先遍历物品还是先遍历背包都是可以的。

    因为两种遍历顺序,对于二维dp数组来说,递推公式所需要的值,二维dp数组里对应的位置都有。

    详细可以看 01背包理论基础(二维数组) (opens new window)中的 【遍历顺序】的讲解

    所以既可以 先遍历物品再遍历背包:

    for (int i = 1; i < n; i++) { // 遍历物品
        for(int j = 0; j <= bagWeight; j++) { // 遍历背包容量
            if (j < weight[i]) dp[i][j] = dp[i - 1][j];
            else dp[i][j] = max(dp[i - 1][j], dp[i][j - weight[i]] + value[i]);
        }
    }
    

    也可以 先遍历背包再遍历物品:

    for(int j = 0; j <= bagWeight; j++) { // 遍历背包容量
        for (int i = 1; i < n; i++) { // 遍历物品
            if (j < weight[i]) dp[i][j] = dp[i - 1][j];
            else dp[i][j] = max(dp[i - 1][j], dp[i][j - weight[i]] + value[i]);
        }
    }
    

    5. 举例推导dp数组

    以本篇举例数据为例,填满了dp二维数组如图:

    因为 物品0 的性价比是最高的,而且 在完全背包中,每一类物品都有无限个,所以有无限个物品0,既然物品0 性价比最高,当然是优先放物品0。

Logo

北京人形旗下天工造物具身智能开源社区,聚焦具身天工与慧思开物两大平台

更多推荐